# Executing on ADD/EDIT CANDIDATE
import sys

import mysql.connector
import string
from nltk.tokenize import word_tokenize
import re
import nltk
from nltk.corpus import stopwords

from bs4 import BeautifulSoup
import re
from nltk.stem import WordNetLemmatizer
from nltk.corpus import stopwords
from nltk.tokenize import word_tokenize

print("Imported and Initiated")
f = open("clean_cv_logs.txt", "w")
f.write("Imported and Initiated in fcc\n")

cvID = sys.argv[1]  # string

dbhost="localhost"
dbuser="root"
dbpassword="root"

dbname="27-11-23"

try:
    mydb = mysql.connector.connect(host=dbhost,user=dbuser,password=dbpassword,database=dbname)
    mycursor = mydb.cursor()
except Exception as e:
    print("Database connectivity failed:", e)
    f.write(("Database connectivity failed\n" + str(e)))
    exit()

try:
    mycursor.execute(
        "SELECT text FROM attachment WHERE data_item_id='%s' and data_item_type = 100 and text != '' and resume=1 ORDER By date_created DESC LIMIT 1 " % (cvID))
    myCvText = mycursor.fetchall()
except Exception as e:
    print("Fetching CV's failed:", e)
    f.write(("Fetching CV's failed:\n"+ str(e)))
    exit()

if(len(myCvText)<1):
    exit()

myCvId = (tuple([cvID]))
myCvText = myCvText[0][0]

# print(myCvText)

lemmatizer = WordNetLemmatizer()
def remove_stop(doc): 
        stop_words = set(stopwords.words('english'))
        word_tokens = word_tokenize(doc)
        filtered_sentence = [w for w in word_tokens if not w.lower() in stop_words]
        filtered_sentence = []
        for w in word_tokens:
            if w not in stop_words:
                filtered_sentence.append(lemmatizer.lemmatize(w))            
        return " ".join(filtered_sentence)
def remove_html_tags_and_links(text):
    soup = BeautifulSoup(text, "html.parser")
    
    # Remove hyperlinks
    for a_tag in soup.find_all('a'):
        a_tag.replace_with(a_tag.text)

    # Remove remaining HTML tags
    cleaned_text = soup.get_text()
    
    # Remove extra whitespaces
    cleaned_text = re.sub(r'\s+', ' ', cleaned_text).strip()
    
    return cleaned_text

def cleanResume(resumeText):
    
    resumeText=remove_html_tags_and_links(resumeText)
    resumeText=remove_stop(resumeText)
    resumeText = re.sub('http\S+\s*', ' ', resumeText)  # remove URl
    resumeText = re.sub('RT|cc', ' ', resumeText)  # remove RT and cc
    resumeText = re.sub('#\S+', '', resumeText)  # remove hashtags
    resumeText = re.sub('@\S+', '  ', resumeText)  # remove mentions
    resumeText = re.sub('[%s]' % re.escape("""!"#$%&'()*+,-./:;<=>?@[\]^_`{|}~"""), ' ', resumeText)  # remove punctuations
    resumeText = re.sub(r'[^\x00-\x7f]',r' ', resumeText) 
    resumeText = re.sub('\s+', ' ', resumeText)  # remove extra whitespace

    resumeText = resumeText.lower()

    bad_word_list = [
                        " li ", " responsibilities ", " work ", " working ", " ul ", " skill ", " skills ", " years ", " year ",
                        " experience ", " experience ",  " knowledge ", " preferably ", " benefit ", " required ", " abilities ",
                        " strong ", " understand ", " possess ", " education ", " degree ", " relevant ", " domain ", " like ", " job ", 
                        " develop ", " developed ", "responsibilities ", " well ", " should ", " can "
                    ]
    
    for element in bad_word_list:
        resumeText = resumeText.replace(element, ' ')


    for i in range(10):
        resumeText = resumeText.replace(" " + str(i) + " ", ' ')

    return resumeText 

# print(all_cv_strings)

all_cv_strings = cleanResume(myCvText)

try:
    mycursor.execute("delete from clean_resume where candidate_id=" + str(myCvId[0]))
    upsertSql = "INSERT INTO clean_resume (candidate_id,clean_text) VALUES (%s,%s) ON DUPLICATE KEY UPDATE clean_text =(%s)"
    upsertVal = (myCvId[0], all_cv_strings, all_cv_strings)
    mycursor.execute(upsertSql, upsertVal)
    mydb.commit()
except Exception as e:
    print("Insertion in Database failed:", e)
    f.write(("Insertion in Database failed\n"+ str(e)))
    exit()

    
print("Insertion Successful\n")
f.write(("Insertion Successful\n"))
print(mycursor.rowcount, "record inserted.")
f.close()
