import mysql.connector
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.metrics.pairwise import cosine_similarity
import sys


mydb = mysql.connector.connect(
host="localhost",
user="root",
password="root",
database="27-11-23"
)
candidate_id = sys.argv[1]

mycursor = mydb.cursor()

mycursor.execute("SELECT c.candidate_id, j.joborder_id AS matching_skills FROM candidate_skills c CROSS JOIN job_skills j WHERE c.skill_id = j.skill_id and candidate_id =" + str(candidate_id) + " GROUP BY c.candidate_id, j.joborder_id")
cvTextWithId = mycursor.fetchall()
if(len(cvTextWithId))==0:
    mycursor.execute("Delete from recommended_jobs where candidate_id=%s"%candidate_id)
    mydb.commit()
    exit()

mycursor.execute("Select candidate_id, clean_text from clean_resume where candidate_id = %s"%str(candidate_id))
candidate_resume_text = mycursor.fetchall()
# print(cvTextWithId)
a, job_ids = zip(*cvTextWithId)
print(job_ids)
if len(job_ids) != 1:
    mycursor.execute("SELECT joborder_id FROM joborder where description = '' and status='active' and joborder_id in %s ORDER BY date_created DESC"%(str(job_ids)))
else:
    mycursor.execute("SELECT joborder_id FROM joborder where description = '' and status='active' and joborder_id = %s ORDER BY date_created DESC"%(job_ids[0]))
uselessJobIds = mycursor.fetchall()
needed_jobs = set(job_ids) - set(uselessJobIds)
print(needed_jobs)
job_ids = tuple(set(job_ids))

if len(needed_jobs) != 1:
    mycursor.execute("SELECT joborder_id, clean_text from clean_joborder where joborder_id in %s"%(str(tuple(needed_jobs))))
else:
    mycursor.execute("SELECT joborder_id, clean_text from clean_joborder where joborder_id = %s"%(str(tuple(needed_jobs)[0])))

jd = mycursor.fetchall()

myJobId, myJobText = zip(*jd)
myJobId = list(myJobId)
myJobText = list(myJobText)

cv_text = candidate_resume_text[0][1]

mycursor.execute("Delete from recommended_jobs where candidate_id=%s"%candidate_id)
insert_sql = "Insert into recommended_jobs (candidate_id, jd_id, score) values (%s, %s, %s)"
result_list = []
j = 0
while j < len(myJobId):
    print(myJobId[j])
    vectorizer = CountVectorizer(ngram_range= (1, 3), token_pattern= "(?u)\\b\\w+\\b")
    count_array = vectorizer.fit_transform([cv_text] + [myJobText[j]]).toarray()
    count_array[count_array>6] = 6
    score = cosine_similarity([count_array[0]], [count_array[1]])[0][0].astype("float16")
    print(score)
    if(score):
        result_list.append((myJobId[j], score))
    j+=1
n = 0
while n < len(result_list):
    print(result_list[n][0])
    insertval = (candidate_id, result_list[n][0], float(result_list[n][1]))
    mycursor.execute(insert_sql, insertval)
    mydb.commit()
    n+=1

print("Results calculated and inserted")

mydb.commit()